#! /bin/bash

PATCH_FILE=$1
NEW_FILES_NAMES=$(mktemp)

help() {
	echo "Usage: "
	echo "\t $0 [patch name]"
}

find_new_file_names() {

	#35: create mode 100644 drivers/staging/phytium-npu/Kconfig
	grep -Inr "create mode" $PATCH_FILE | awk '{ print $5 }' > $NEW_FILES_NAMES
}

create_new_file() {
	echo "creating file $1"
	start_line="$(grep -Inr "^\+\+\+ b\/${1}$" $PATCH_FILE | sed 's/:/ /g' | awk '{ print $1 }')"
	start_line=$((start_line + 2))
	lines="$(tail -n +${start_line} $PATCH_FILE | grep -In -m 1 "^diff --git a/"  | sed 's/:/ /g' | awk '{ print $1 }')"
	lines=$((lines - 1))

	if [ $lines -lt 0 ];then
		lines="$(tail -n +${start_line} $PATCH_FILE | grep -In -m 1 "^--"  | sed 's/:/ /g' | awk '{ print $1 }')"
		lines=$((lines - 1))
	fi

	#echo "create_new_file $start_line $lines"
	if [ ! -d "$(dirname $1)" ];then
		mkdir -p $(dirname $1)
	fi
	tail -n +$start_line $PATCH_FILE | head -n $lines  > $1
	sed -i 's/^+//g' $1
}

if [ $# -lt 1 ];then
	help
	exit 1
fi

find_new_file_names $1

for LINE in $(cat $NEW_FILES_NAMES)
do
	create_new_file $LINE
done

if [ -f $NEW_FILES_NAMES ];then
	rm $NEW_FILES_NAMES
fi
